add/urls.py
from django.urls import path
from . import views

app_name = 'add'

urlpatterns = [
    path('', views.index, name='index'),
]

archive/urls.py
from django.urls import path
from . import views

app_name = 'archive'

urlpatterns = [
    path('', views.index, name='index'),
]

authentications/urls.py
from django.urls import path
from . import views

app_name = 'authentications'

urlpatterns = [
    path('login/', views.login, name='login'),
    path('register/', views.register, name='register'),
    path('update/', views.update, name='update'),
    path('logout/', views.logout, name='logout'),
]

core/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('authentications/', include('authentications.urls')),
    path('add/', include('add.urls')),
    path('archive/', include('archive.urls')),
    path('', include('view.urls')),
]

view/urls.py
from django.urls import path
from . import views

app_name = 'view'

urlpatterns = [
    path('', views.index, name='home'),
    path('finish/', views.finish, name='finish'),
    path('delete/', views.delete, name='delete'),
]

add/models.py
from django.db import models

# Create your models here.

archive/models.py
from django.db import models

# Create your models here.

authentications/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.

class Account(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE, primary_key=True)
    name = models.CharField(max_length=50)
    email = models.EmailField()

    def save(self):
        super().save()

view/models.py
from django.db import models
from django.utils import timezone
from django.contrib.auth.models import User
 
class Todo(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    title=models.CharField(max_length=100)
    details=models.TextField()
    date=models.DateField()
    finished=models.BooleanField(default=False)

    def __str__(self):
        return self.title

add/forms.py
from django import forms
from view import models

class TodoCreateForm(forms.ModelForm):
    class Meta:
        model = models.Todo
        fields = ['title', 'details']

authentications/forms.py
from django import forms
from . import models

class AccountUpdateForm(forms.ModelForm):
    class Meta:
        model = models.Account
        fields = ['name', 'email']

add/views.py
from django.shortcuts import render, redirect
from . import forms

# Create your views here.

def index(req):
    if req.user.is_authenticated:
        if req.method == 'POST':
            form = forms.TodoCreateForm(req.POST)
            form.instance.user = req.user
            form.instance.date = req.POST['date']
            if form.is_valid():
                form.save()
            return redirect('view:home')
        else:
            form = forms.TodoCreateForm()
        return render(req, 'add/index.html', {'page_title': 'Add List Page', 'form': form})
    else:
        return redirect('authentications:login')

archive/views.py
from django.shortcuts import render, redirect
from view import models

# Create your views here.

def index(req):
    if req.user.is_authenticated:
        if req.GET.get('search') is not None:
            search = req.GET.get('search')
            data = req.user.todo_set.filter(title__contains=search, finished=True)
        else:
            data = req.user.todo_set.filter(finished=True)
        return render(req, 'archive/index.html', {'page_title': 'Archive Page', 'todo_list': data})
    else:
        return redirect('authentications:login')

authentications/views.py
from django.shortcuts import render, redirect
from django.contrib.auth import authenticate, login as auth_login, logout as auth_logout
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm
from django.http import HttpResponse
from django.urls import reverse
from . import forms, models
import json

# Create your views here.

def login(req):
    if req.user.is_authenticated:
        return redirect('/')
    if req.method == 'POST':
        username = req.POST['username']
        password = req.POST['password']
        user = authenticate(req, username=username, password=password)
        if user is not None:
            auth_login(req, user)
            return HttpResponse(json.dumps({"message": "Success"}), content_type="application/json", status=200)
        else:
            return HttpResponse(json.dumps({"message": "Invalid"}), content_type="application/json", status=401)
    else:
        form = AuthenticationForm()
        return render(req, 'authentications/login.html', {'page_title': 'Login Page', 'form': form})

def register(req):
    if req.user.is_authenticated:
        return redirect('/')
    if req.method == 'POST':
        form = UserCreationForm(req.POST)
        if form.is_valid():
            form.save()
            username = form.cleaned_data.get('username')
            password = form.cleaned_data.get('password1')
            user = authenticate(req, username=username, password=password)
            auth_login(req, user)
            return redirect('/')
        else:
            return render(req, 'authentications/register.html', {'page_title': 'Register Page', 'form': form}, status=400)
    else:
        form = UserCreationForm()
        return render(req, 'authentications/register.html', {'page_title': 'Register Page', 'form': form})

def update(req):
    if req.user.is_authenticated:
        if req.method == 'POST':
            form = forms.AccountUpdateForm(req.POST)
            form.instance.user = req.user
            if form.is_valid():
                form.save()
            return render(req, 'authentications/update.html', {'page_title': 'Update Profile Page', 'form': form})
        else:
            try:
                form = forms.AccountUpdateForm(instance=req.user.account)
            except Exception as e:
                form = forms.AccountUpdateForm()
            return render(req, 'authentications/update.html', {'page_title': 'Update Profile Page', 'form': form})
    else:
        return redirect(reverse('authentications:login'))

def logout(req):
    auth_logout(req)
    return redirect('/authentications/login')

view/views.py
from django.shortcuts import render, redirect
from . import models

# Create your views here.

def index(req):
    if req.user.is_authenticated:
        if req.GET.get('search') is not None:
            search = req.GET.get('search')
            data = req.user.todo_set.filter(title__contains=search, finished=False)
        else:
            data = req.user.todo_set.filter(finished=False)
        return render(req, 'view/index.html', {'page_title': 'Home Page', 'todo_list': data})
    else:
        return redirect('authentications:login')

def finish(req):
    if req.user.is_authenticated:
        if req.GET.get('id') is not None:
            id = req.GET.get('id')
            try:
                todo = req.user.todo_set.get(pk=id)
                todo.finished = True
                todo.save()
            except:
                pass
        return redirect('view:home')
    else:
        return redirect('authentications:login')

def delete(req):
    if req.user.is_authenticated:
        if req.GET.get('id') is not None:
            id = req.GET.get('id')
            try:
                todo = req.user.todo_set.get(pk=id)
                todo.delete()
            except:
                pass
        return redirect('view:home')
    else:
        return redirect('authentications:login')

add/templates/add/index.html
{% extends 'layouts/base.html' %} 
{% load crispy_forms_tags %} 
{% load static %}

{% block style %}
<link rel="stylesheet" href="{% static 'style/Core.module.css' %}" />
<link
  href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css"
  rel="stylesheet"
  integrity="sha384-wvfXpqpZZVQGK6TAh5PVlGOfQNHSoD2xbE+QkPxCAFlNEevoEH3Sl0sibVcOQVnN"
  crossorigin="anonymous"
/>

<script
  src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.23.0/moment.min.js"
  integrity="sha256-VBLiveTKyUZMEzJd6z2mhfxIqz3ZATCuVMawPZGzIfA="
  crossorigin="anonymous"
></script>

<link
  rel="stylesheet"
  href="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.1.2/css/tempusdominus-bootstrap-4.min.css"
  integrity="sha256-XPTBwC3SBoWHSmKasAk01c08M6sIA5gF5+sRxqak2Qs="
  crossorigin="anonymous"
/>
<script
  src="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.1.2/js/tempusdominus-bootstrap-4.min.js"
  integrity="sha256-z0oKYg6xiLq3yJGsp/LsY9XykbweQlHl42jHv2XTBz4="
  crossorigin="anonymous"
></script>
{% endblock style %} 

{% block body %}
<nav class="navbar navbar-expand-lg navbar-light p-1 p-lg-4">
  <a class="navbar-brand font-weight-bold mx-4 textMainDark" href="#">PACIL-LIST</a>
  <button
    class="navbar-toggler"
    type="button"
    data-toggle="collapse"
    data-target="#navbarSupportedContent"
    aria-controls="navbarSupportedContent"
    aria-expanded="false"
    aria-label="Toggle navigation"
  >
    <span class="navbar-toggler-icon"></span>
  </button>

  <div
    class="collapse navbar-collapse d-flex flex-column flex-lg-row"
    id="navbarSupportedContent"
  >
    <form
      class="form-inline my-2 my-lg-0 mr-auto flex-grow flex-fill w-100"
      action="{% url 'view:home' %}"
      method="GET"
    >
      <input
        class="form-control mr-sm-2 w-100 shadow-box border border-white px-4"
        name="search"
        type="search"
        placeholder="Search"
        aria-label="Search"
      />
      <button class="btn btn-outline-success my-2 my-sm-0 d-none" type="submit">
        Search
      </button>
    </form>
    <ul class="navbar-nav">
      <li class="nav-item mx-2">
        <a class="nav-link" href="/">Home</a>
      </li>
      <li class="nav-item mx-2">
        <a
          class="nav-link textSecondaryDark font-weight-bold"
          href="{% url 'add:index' %}"
          >Add</a
        >
      </li>
      <li class="nav-item mx-2">
        <a class="nav-link" href="{% url 'archive:index' %}">Archive</a>
      </li>
      <li class="nav-item mx-2">
        <a
          class="nav-link font-weight-bold btn btn-outline-secondary px-3"
          href="{% url 'authentications:logout' %}"
          >Logout</a
        >
      </li>
    </ul>
  </div>
</nav>

<div class="cover-container d-flex w-100 h-100 p-3 mx-auto flex-column">
  <div class="card shadow-box border border-white p-5">
    <h3 class="textSecondaryDark font-weight-bold text-center">Add Tugas</h3>
    <form class="mt-3" action="" method="post">
      {% csrf_token %} {{ form|crispy }}
      <div id="div_id_title" class="form-group">
        <label for="id_date" class="requiredField">
          Date<span class="asteriskField">*</span>
        </label>
        <div class="">
          <input
            type="date"
            name="date"
            id="datetimepicker1"
            class="form-control"
            required=""
            id="id_date"
          />
        </div>
      </div>
      <button type="submit" class="btn w-100 bgSecondaryDark text-white mt-3">
        Submit
      </button>
    </form>
  </div>
</div>
{% endblock body %} 

{% block script %}
<script>
  $(function () {
    $("#datetimepicker1").datetimepicker();
  });
</script>
{% endblock script %}

archive/templates/archive/index.html
{% extends 'layouts/base.html' %} 
{% load crispy_forms_tags %} 
{% load static %}

{% block style %} 
<link rel="stylesheet" href="{% static 'style/Core.module.css' %}" />
{% endblock style %} 

{% block body %}
<nav class="navbar navbar-expand-lg navbar-light p-1 p-lg-4">
  <a class="navbar-brand font-weight-bold mx-4 textMainDark" href="#">PACIL-LIST</a>
  <button
    class="navbar-toggler"
    type="button"
    data-toggle="collapse"
    data-target="#navbarSupportedContent"
    aria-controls="navbarSupportedContent"
    aria-expanded="false"
    aria-label="Toggle navigation"
  >
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse d-flex flex-column flex-lg-row" id="navbarSupportedContent">
    <form class="form-inline my-2 my-lg-0 mr-auto flex-grow flex-fill w-100" action="" method="GET">
      <input
        class="form-control mr-sm-2 w-100 shadow-box border border-white px-4"
        name="search"
        type="search"
        placeholder="Search from archive"
        aria-label="Search"
      />
      <button class="btn btn-outline-success my-2 my-sm-0 d-none" type="submit">
        Search
      </button>
    </form>
    <ul class="navbar-nav">
      <li class="nav-item mx-2">
        <a class="nav-link" href="/">Home</a>
      </li>
      <li class="nav-item mx-2">
        <a class="nav-link" href="{% url 'add:index' %}">Add</a>
      </li>
      <li class="nav-item mx-2">
        <a class="nav-link textSecondaryDark font-weight-bold" href="{% url 'archive:index' %}">Archive</a>
      </li>
      <li class="nav-item mx-2">
        <a class="nav-link font-weight-bold btn btn-outline-secondary px-3" href="{% url 'authentications:logout' %}">Logout</a>
      </li>
    </ul>
  </div>
</nav>

<div class="cover-container d-flex w-100 h-100 p-3 mx-auto flex-column">
  {% for todo in todo_list %}
  <div class="card shadow-box border border-white mb-3">
    <div class="card-body">
      <h4 class="card-title font-weight-bold textSecondaryDark">{{ todo.title }}</h4>
      <p class="card-text">{{ todo.details }}</p>
      <h5 style="text-decoration: line-through;" class="card-subtitle font-weight-bold mb-3">Deadline: {{ todo.date|date:'d-m-Y' }}</h5>
    </div>
  </div>
  {% endfor %}
</div>
{% endblock body %} 

{% block script %} 
{% endblock script %}

authentications/templates/authentications/login.html
{% extends 'layouts/base.html' %}

{% load crispy_forms_tags %}

{% load static %}

{% block style %}
<link rel="stylesheet" href="{% static 'style/Auth.module.css' %}" />
{% endblock style %}

{% block body %}
<div class="auth-wrapper">
  <h1 class="textMainDark font-weight-bold text-center mb-4">PACIL-LIST</h1>
  <div class="auth-inner shadow-box">
    <h3 class="textSecondaryDark font-weight-bold text-center">Login</h3>
    <form class="mt-3" method="post">
      {% csrf_token %}
      {{ form|crispy }}
      <small id="errorlogin" class="form-text text-muted textSecondaryDark text-center"></small>
      <button type="submit" class="btn w-100 bgSecondaryDark text-white mt-3" id="login_submit">
        Submit
      </button>
    </form>
    <p class="text-center mt-3">Need an account? <a href="{% url 'authentications:register' %}" class="textSecondaryDark">Register</a></p>
  </div>
</div>
{% endblock body %}

{% block script %}
<script src="{% static 'script/authApp.js' %}"></script>
{% endblock script %}

authentications/templates/authentications/register.html
{% extends 'layouts/base.html' %}

{% load crispy_forms_tags %}

{% load static %}

{% block style %}
<link rel="stylesheet" href="{% static 'style/Auth.module.css' %}" />
{% endblock style %}

{% block body %}
<div class="auth-wrapper">
  <h1 class="textMainDark font-weight-bold text-center mb-4">PACIL-LIST</h1>
  <div class="auth-inner shadow-box">
    <h3 class="textSecondaryDark font-weight-bold text-center">Register</h3>
    <form class="mt-3" method="post">
      {% csrf_token %}
      {{ form|crispy }}
      <button type="submit" class="btn w-100 bgSecondaryDark text-white mt-3">
        Submit
      </button>
    </form>
    <p class="text-center mt-3">Already have an account? <a href="{% url 'authentications:login' %}" class="textSecondaryDark">Login</a></p>
  </div>
</div>
{% endblock body %}

{% block script %}
<script src="{% static 'script/authApp.js' %}"></script>
{% endblock script %}

authentications/templates/authentications/update.html
{% extends 'layouts/base.html' %}

{% load crispy_forms_tags %}

{% load static %}

{% block style %}
<link rel="stylesheet" href="{% static 'style/Auth.module.css' %}" />
{% endblock style %}

{% block body %}
<div class="auth-wrapper">
  <h1 class="textMainDark font-weight-bold text-center mb-4">PACIL-LIST</h1>
  <div class="auth-inner shadow-box">
    <h3 class="textSecondaryDark font-weight-bold text-center">Update Profile</h3>
    <form class="mt-3" method="post">
      {% csrf_token %}
      {{ form|crispy }}
      <button type="submit" class="btn w-100 bgSecondaryDark text-white mt-3">
        Submit
      </button>
    </form>
  </div>
</div>
{% endblock body %}

{% block script %}
<script src="{% static 'script/authApp.js' %}"></script>
{% endblock script %}

templates/layouts/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta
      name="description"
      content="This is our final project in the course of web design and development, Faculty of Computer Science, University of Indonesia"
    />
    <meta name="author" content="Gilang Mahardika Pratama, Habibullah Akbar, I Gusti Aswina Mahendra, Yahya Abdurrohman Alghifari" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <link
      rel="stylesheet"
      href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css"
      integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk"
      crossorigin="anonymous"
    />
    <link rel="stylesheet" href="{% static 'style/Global.css' %}" />
    {% block style %}
    {% endblock style %}
    <link
      rel="icon"
      href="{% static 'assets/favicon.ico' %}"
      type=" image/x-icon "
    />
    <title>{{ page_title }}</title>
  </head>

  <body>
    <div class="top-line"></div>
    {% block body %}
    {% endblock body %}
    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"
      integrity="sha512-894YE6QWD5I59HgZOGReFYm4dnWc1Qt5NtvYSaNcOP+u1T9qYdvdihz0PPSiiqn/+/3e7Jo4EaG7TubfWGUrMQ=="
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
      integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"
      integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdnjs.cloudflare.com/ajax/libs/jquery-cookie/1.4.1/jquery.cookie.js"
      integrity="sha256-uEFhyfv3UgzRTnAZ+SEgvYepKKB0FW6RqZLrqfyUNug="
      crossorigin="anonymous"
    ></script>
    {% block script %}
    {% endblock script %}
  </body>
</html>

view/templates/view/index.html
{% extends 'layouts/base.html' %} 
{% load crispy_forms_tags %} 
{% load static %}

{% block style %} 
<link rel="stylesheet" href="{% static 'style/Core.module.css' %}" />
{% endblock style %} 

{% block body %}
<nav class="navbar navbar-expand-lg navbar-light p-1 p-lg-4">
  <a class="navbar-brand font-weight-bold mx-4 textMainDark" href="#">PACIL-LIST</a>
  <button
    class="navbar-toggler"
    type="button"
    data-toggle="collapse"
    data-target="#navbarSupportedContent"
    aria-controls="navbarSupportedContent"
    aria-expanded="false"
    aria-label="Toggle navigation"
  >
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse d-flex flex-column flex-lg-row" id="navbarSupportedContent">
    <form class="form-inline my-2 my-lg-0 mr-auto flex-grow flex-fill w-100" action="" method="GET">
      <input
        class="form-control mr-sm-2 w-100 shadow-box border border-white px-4"
        name="search"
        type="search"
        placeholder="Search"
        aria-label="Search"
      />
      <button class="btn btn-outline-success my-2 my-sm-0 d-none" type="submit">
        Search
      </button>
    </form>
    <ul class="navbar-nav">
      <li class="nav-item mx-2">
        <a class="nav-link textSecondaryDark font-weight-bold" href="/">Home</a>
      </li>
      <li class="nav-item mx-2">
        <a class="nav-link" href="{% url 'add:index' %}">Add</a>
      </li>
      <li class="nav-item mx-2">
        <a class="nav-link" href="{% url 'archive:index' %}">Archive</a>
      </li>
      <li class="nav-item mx-2">
        <a class="nav-link font-weight-bold btn btn-outline-secondary px-3" href="{% url 'authentications:logout' %}">Logout</a>
      </li>
    </ul>
  </div>
</nav>

<div class="cover-container d-flex w-100 h-100 p-3 mx-auto flex-column">
  {% for todo in todo_list %}
  <div class="card shadow-box border border-white mb-3">
    <div class="card-body">
      <h4 class="card-title font-weight-bold textSecondaryDark">{{ todo.title }}</h4>
      <p class="card-text">{{ todo.details }}</p>
      <h5 class="card-subtitle font-weight-bold mb-3">Deadline: {{ todo.date|date:'d-m-Y' }}</h5>
      <div class="d-flex">
        <form action="{% url 'view:finish' %}" method="GET">
          <input
            class="d-none"
            name="id"
            value="{{ todo.pk }}"
          />
          <button class="btn bgSecondaryDark text-white mr-2" type="submit">
            Finish
          </button>
        </form>
        <form action="{% url 'view:delete' %}" method="GET">
          <input
            class="d-none"
            name="id"
            value="{{ todo.pk }}"
          />
          <button class="btn bgMainDark text-white" type="submit">
            Remove
          </button>
        </form>
      </div>
    </div>
  </div>
  {% endfor %}
</div>
{% endblock body %} 

{% block script %} 
{% endblock script %}